;
; FMhCopb`
;

	relaxed on

BGMON		equ	$0026
TIMERB		equ	$0027
TIMERBCNT	equ	$0028
BGM_ENB		equ	$002f
PRNO		equ	$0035


; 0xea80`0xeaff
; BGM炷
; AregFvOԍ
;

	org	$ea80
	jp	BGMSTART	; 0xea80
	jp	BGMONOFF	; 0xea83

;
; BGM ON/OFF
;
BGMONOFF:
	ld	a,(BGM_ENB_OLD)
	ld	b,a
	ld	a,(BGM_ENB)
	ld	(BGM_ENB_OLD),a
	xor	b
	ret	z

	ex	af,af'
	push	af

	ld	a,b

	push	de
	push	hl
	exx
	push	bc
	push	de
	push	hl
	push	ix
	push	iy

	or	a
	jr	z,.boff

		;
		; ONOFF
		;
	call	BGMSTOP		; BGM~
	jr	.end

.boff:
		;
		; OFFON
		;
	call	BGMRESTART	; BGMJn

.end:
	pop	iy
	pop	ix
	pop	hl
	pop	de
	pop	bc
	exx
	pop	hl
	pop	de
	pop	af
	ex	af,af'
	ret

BGM_ENB_OLD:
	db	$ff



BGMRESTART:
	ld	a,(PRNO)
BGMSTART:
	ld	l,a
	ld	h,$00
	ld	de,BGMTITLE
	add	hl,de
	ld	b,(hl)
	ld	a,(BGMNO)
	cp	b
	ret	z
	ld	a,b
	ld	(BGMNO),a

	dec	a
	add	a,a		; x2
	ld	l,a
	ld	h,$00
	ld	de,BGMTABLE
	add	hl,de
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a

	push	hl
	call	$ed54+1		; BGM~
	pop	hl

	jp	(hl)

;
; BGM~
;
BGMSTOP:
	call	$ed54+1		; BGM~
	ld	a,$ff
	ld	(BGMNO),a
	ret

BGMNO:	db	$ff

BGMTITLE:
	db	$02	; TOWN
	db	$03	; tB[h
	db	$04	; _W
	db	$05	; X^[
	db	$02	; GUILD
	db	$02	; ARMORY
	db	$01	; Q[N
	db	$05	; GAMEOVER

BGMTABLE:
	dw	$ee0c+1	; 0x01FQ[N
	dw	$ee42+1	; 0x02FTOWN
	dw	$ee78+1	; 0x03FtB[h
	dw	$eeae+1	; 0x04F_W
	dw	$eee4+1	; 0x05FX^[


; 0xeb00`
; ̂܂܎gp
;
	org	$eb00
	db	$ff

; 0xeb3b`0xeb3c
; FMւ̏ói|[gύXj
;
	org	$eb3b
	ld	c,$a0

; 0xeb3d`
; ̂܂܎gp
;
	org	$eb3d
	db	$ff

; 0xeb47`0xeb48
; FM̓́i|[gύXj
;
	org	$eb47
	inc	c
	inc	c

; 0xeb49`
; ̂܂܎gp
;
	org	$eb49
	db	$ff

; 0xed30`0xed53
; FMւ̊荞݃^C~O
;
	org	$ed30
	pop	af
	di
	cpl
	ld	(TIMERB),a
	ld	(TIMERBCNT),a
	ld	a,$ff
	ld	(BGMON),a
	ei
	ret

; 0xed54`
; ̂܂܎gp
;
	org	$ed54
	db	$ff

; 0xed58`0xed5f
; FM̒~
;
	org	$ed58
	xor	a
	ld	(BGMON),a
	ret

; 0xed60`0xed6c
; FM荞
;
	org	$ed60
	ex	af,af'
	push	af
	push	bc
	push	de
	push	hl
	exx
	push	bc
	push	de
	push	hl
	push	ix
	push	iy

; 0xed6d`
; ̂܂܎gp
;
	org	$ed6d
	db	$ff

; 0xedee`0xee00
; FM荞
;
	org	$edee
	pop	iy
	pop	ix
	pop	hl
	pop	de
	pop	bc
	exx
	pop	hl
	pop	de
	pop	bc
	pop	af
	ex	af,af'
	ret

; 0xee01`
; ̂܂܎gp
;
	org	$ee01
	db	$ff

; 0xee40`0xee41
; BGM#1炷
;
	org	$ee40
	ret

; 0xee42`
; ̂܂܎gp
;
	org	$ee42
	db	$ff

; 0xee76`0xee77
; BGM#2炷
;
	org	$ee76
	ret

; 0xee78`
; ̂܂܎gp
;
	org	$ee78
	db	$ff

; 0xeeac`0xeead
; BGM#3炷
;
	org	$eeac
	ret

; 0xeeae`
; ̂܂܎gp
;
	org	$eeae
	db	$ff

; 0xeee2`0xeee3
; BGM#4炷
;
	org	$eee2
	ret

; 0xeee4`
; ̂܂܎gp
;
	org	$eee4
	db	$ff

; 0xef18`0xef19
; BGM#5炷
;
	org	$ef18
	ret

; 0xef1a`
; ̂܂܎gp
;
	org	$ef1a
	db	$ff


end
